VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "www.ActiveVB.de"
   ClientHeight    =   3570
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4440
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3570
   ScaleWidth      =   4440
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton Command3 
      Caption         =   "Sortieren (absteigend)"
      Height          =   495
      Left            =   2280
      TabIndex        =   3
      Top             =   1320
      Width           =   2055
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Sortieren (aufsteigend)"
      Height          =   495
      Left            =   2280
      TabIndex        =   2
      Top             =   720
      Width           =   2055
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Mischen"
      Height          =   495
      Left            =   2280
      TabIndex        =   1
      Top             =   120
      Width           =   2055
   End
   Begin VB.ListBox List1 
      Height          =   3375
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   2055
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source!

Option Explicit

' ListBox-Eintrge sortieren
' LB Sorted = False sonst wird autom. aufsteigend sortiert!
Public Function LBSortItem(ByRef hLBox As ListBox, _
                           ByRef hOrder As Boolean) As Boolean
    
    Dim rApi        As Long
    Dim idx         As Integer
    Dim maxElements As Integer
    Dim tmpLB()     As String
    
    Debug.Print Timer & " " & Time$
    If hOrder = True Then
        
        'LB-Sortierung absteigend
        If hLBox.Sorted = True Then
            
            ' kann nicht sortiert werden !
            LBSortItem = False
            Exit Function
        End If
        
    Else
        
        ' LB-Sortierung aufsteigend (Standard!)
        If hLBox.Sorted = True Then
        
            'keine weitere Sortierung notwendig!
            LBSortItem = True
            Exit Function
        End If
    End If
    
    ' Eintrge sortieren
    ' zuerst alle Eintrge in Array u. sortieren
    ReDim tmpLB(hLBox.ListCount - 1)
    maxElements = hLBox.ListCount
    For idx = 0 To hLBox.ListCount - 1
        tmpLB(idx) = hLBox.List(idx)
    Next
    
    ' Array sortieren
    'Call SortArray1(tmpLB())  ' zu langsam
    Call SortArray2(tmpLB(), 0, maxElements - 1)
    
    ' LB lschen/leeren u. wieder fllen
    hLBox.Clear
    For idx = 0 To maxElements - 1
        If hOrder = True Then
           hLBox.AddItem tmpLB(idx), 0
        Else
           hLBox.AddItem tmpLB(idx)
        End If
    Next
    Debug.Print Timer; " "; Time$
End Function

' Array sortieren - Variante 1   >BubbleSort<
'  < 1 sek. bei 1.000 / ca. 1 min bei 10.000 Strings
Public Sub SortArray1(ByRef tmpArray() As String)
    Dim tmpString   As String
    Dim sortIdx     As Long
    Dim sortFlag    As Boolean
    
    sortFlag = True
    Do While sortFlag = True
       sortFlag = False
       For sortIdx = 1 To UBound(tmpArray())
           If tmpArray(sortIdx) < tmpArray(sortIdx - 1) Then
              tmpString = tmpArray(sortIdx)
              tmpArray(sortIdx) = tmpArray(sortIdx - 1)
              tmpArray(sortIdx - 1) = tmpString
              sortFlag = True
           End If
       Next
    Loop
End Sub

' Array sortieren - Variante 2   >QuickSort<
'  < 1 sek. bei 1.000 / ca. 1 sek bei 10.000 Strings
Public Sub SortArray2(ByRef tmpArray() As String, ByVal idxLo As Long, ByVal idxHi As Long)
  Dim tmpString As String
  Dim tmpSwap   As String
  Dim tmpLow    As Long
  Dim tmpHi     As Long
  
  tmpLow = idxLo
  tmpHi = idxHi
  tmpString = tmpArray((idxLo + idxHi) / 2)
  
  While (tmpLow <= tmpHi)
    While (tmpArray(tmpLow) < tmpString) And (tmpLow < idxHi)
      tmpLow = tmpLow + 1
    Wend
  
    While (tmpString < tmpArray(tmpHi)) And (tmpHi > idxLo)
      tmpHi = tmpHi - 1
    Wend
  
    If (tmpLow <= tmpHi) Then
      tmpSwap = tmpArray(tmpLow)
      tmpArray(tmpLow) = tmpArray(tmpHi)
      tmpArray(tmpHi) = tmpSwap
      tmpLow = tmpLow + 1
      tmpHi = tmpHi - 1
    End If
  Wend
   
  If (idxLo < tmpHi) Then SortArray2 tmpArray(), idxLo, tmpHi
  If (tmpLow < idxHi) Then SortArray2 tmpArray(), tmpLow, idxHi
End Sub

'Sortieren (absteigend)
Private Sub Command2_Click()
    LBSortItem List1, True
End Sub

'Sortieren (aufsteigend)
Private Sub Command3_Click()
    LBSortItem List1, False
End Sub

Private Sub Form_Load()
    Command1.Caption = "Mischen"
    Command2.Caption = "Sortieren (aufsteigend)"
    Command3.Caption = "Sortieren (absteigend)"
    
    Call Command1_Click
End Sub

Private Sub Command1_Click()
    Dim temp As String
    Dim i As Integer
    Dim j As Integer
    
    List1.Clear
    
    'Die Liste mi 10.000 Eintrgen, die 5 Zeichen lang sind, fllen.
    For i = 1 To 10000
        For j = 1 To 5
            temp = temp & RandomChar()
        Next j
        
        List1.AddItem temp
        temp = ""
    Next i
End Sub

'Einen zuflligen Buchstaben ausgeben
Private Function RandomChar() As String
    Const CHARS As String = _
        "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz"
    
    Randomize Timer
    RandomChar = Mid(CHARS, Int(Rnd * (Len(CHARS))) + 1, 1)
End Function
